/*
 * Driver for EIP97 cryptographic accelerator.
 *
 * Copyright (c) 2018 AVM GmbH <fritzbox_info@avm.de>
 *
 * SPDX-License-Identifier: GPL-2.0-only
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This driver is heavily based on the Mediatek driver from Ryder Lee.
 *
 */

#ifndef __EIP97_AEAD_H_
#define __EIP97_AEAD_H_

#include "eip97-platform.h"

int eip97_aead_register_algs(struct eip97_cryp *cryp);
void eip97_aead_finish(enum eip97_op_type *op_type, eip97_err_t err,
		       unsigned int bytes);
void eip97_aead_unregister_algs(struct eip97_cryp *cryp);

#endif /* __EIP97_AEAD_H_ */
